The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::TwoZero Class Reference

STK two-zero filter class. More...

`#include <TwoZero.h>`

Inheritance diagram for stk::TwoZero:

List of all members.

## Public Member Functions
| TwoZero ()
| Default constructor creates a second-order pass-through filter.
| ~TwoZero ()
| Class destructor.
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.
void | setB0 (StkFloat b0)
| Set the b[0] coefficient value.
void | setB1 (StkFloat b1)
| Set the b[1] coefficient value.
void | setB2 (StkFloat b2)
| Set the b[2] coefficient value.
void | setCoefficients (StkFloat b0, StkFloat b1, StkFloat b2, bool clearState=false)
| Set all filter coefficients.
void | setNotch (StkFloat frequency, StkFloat radius)
| Sets the filter coefficients for a "notch" at frequency (in Hz).
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

## Detailed Description

STK two-zero filter class.

This class implements a two-zero digital filter. A method is provided for creating a "notch" in the frequency response while maintaining a constant filter gain.

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Member Function Documentation

void stk::TwoZero::setNotch | ( | StkFloat | frequency,
|  | StkFloat | radius |
| ) |  |  |

Sets the filter coefficients for a "notch" at frequency (in Hz).

This method determines the filter coefficients corresponding to two complex-conjugate zeros with the given frequency (in Hz) and radius from the z-plane origin. The coefficients are then normalized to produce a maximum filter gain of one (independent of the filter gain parameter). The resulting filter frequency response has a "notch" or anti-resonance at the given frequency. The closer the zeros are to the unit-circle (radius close to or equal to one), the narrower the resulting notch width. The frequency value should be between zero and half the sample rate. The radius value should be positive.

StkFrames & stk::TwoZero::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

    00103 {
    00104 #if defined(_STK_DEBUG_)
    00105   if ( channel >= frames.channels() ) {
    00106     oStream_ << "TwoZero::tick(): channel and StkFrames arguments are incompatible!";
    00107     handleError( StkError::FUNCTION_ARGUMENT );
    00108   }
    00109 #endif
    00110
    00111   StkFloat *samples = &frames[channel];
    00112   unsigned int hop = frames.channels();
    00113   for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00114     inputs_[0] = gain_ * *samples;
    00115     *samples = b_[2] * inputs_[2] + b_[1] * inputs_[1] + b_[0] * inputs_[0];
    00116     inputs_[2] = inputs_[1];
    00117     inputs_[1] = inputs_[0];
    00118   }
    00119
    00120   lastFrame_[0] = *(samples-hop);
    00121   return frames;
    00122 }

StkFrames & stk::TwoZero::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0` |
| ) |  |  | `[inline]`

Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

    00125 {
    00126 #if defined(_STK_DEBUG_)
    00127   if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
    00128     oStream_ << "TwoZero::tick(): channel and StkFrames arguments are incompatible!";
    00129     handleError( StkError::FUNCTION_ARGUMENT );
    00130   }
    00131 #endif
    00132
    00133   StkFloat *iSamples = &iFrames[iChannel];
    00134   StkFloat *oSamples = &oFrames[oChannel];
    00135   unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
    00136   for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop ) {
    00137     inputs_[0] = gain_ * *iSamples;
    00138     *oSamples = b_[2] * inputs_[2] + b_[1] * inputs_[1] + b_[0] * inputs_[0];
    00139     inputs_[2] = inputs_[1];
    00140     inputs_[1] = inputs_[0];
    00141   }
    00142
    00143   lastFrame_[0] = *(oSamples-oHop);
    00144   return iFrames;
    00145 }

The documentation for this class was generated from the following file:

- TwoZero.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.